.\" Man page for SlingShot extensions.
.TH SSPKG 3 "18 Nov 1991"
.SH NAME
sspkg \- SlingShot 1.0 extensions to the XView toolkit
.SH DESCRIPTION
.LP
The SlingShot extensions are a set of XView objects that
are useful for implementing graphical objects in a
canvas.  They provide callbacks for double click and
drag and drop, provide layout policies, and handle 
repainting.  These extensions use the XView subclassing 
scheme so the standard XView API (xv_create, xv_set, etc.) 
is applicable.
.LP
The following extension packages are included:
.LP
Rectobj
.RS
A basic object that is used as a superclass for all the other
objects in this package.  In its simpliest form, it is a
rectangular area inside of a canvas_shell.  It can contain
multiple "children" rectobjs.  (Folks familar with the
Xt Intrinsics' RectObj gadget will recognize that this object is
very similar in purpose.)
.LP
.RE
Canvas_shell
.RS
This is a subclass of the XView canvas with a few additions.  It
can contain multiple "children" rectobjs.
.LP
.RE
Drawimage
.RS
This is a rectobj with a picture (a server image object).  It is
selectable by a left mouse click, is aware of double clicks, and can
be dragged and dropped.
.LP
.RE
Drawtext
.RS
This is a rectobj with a text string and a font.  It is selectable by
a left mouse click, is aware of double clicks, and can be dragged
and dropped.
.LP
.RE
Drawicon
.RS
This is a combination of a drawimage object and a drawtext object
positioned in file manager style.
.LP
.RE
Drawarea
.RS
This is a sketchpad object that applications can doodle into
without having to worry about scaling or repainting.
.LP
.RE
Drawline
.RS
This is a simple line between two endpoints.  Each endpoint
can have an arrowhead.
.LP
.RE
Drawrect
.RS
This is a filled or opaque rectangular area.
.LP
.RE
Grip
.RS
This is an object that can be dragged within the window, usually
used to alter the state of another object.  This can be viewed
as a slider that moves in two dimensions.
.LP
.RE
Array_tile
.RS
This object positions other objects in a flat two dimensional array.
Each child can be addressed by its row column position.
.LP
.RE
Tree
.RS
This object positions its children in a hierarchy.  Children
are visually connected with Drawline objects.
.LP
.RE
Further documentation is available in the doc subdirectory of the
source code distribution.
.SH CAVEATS
.LP
The selections and drag and drop operations do not interact with 
other applications and XView 3.0 selection and dnd packages are
not used.  A future release will address these problems, and
will unfortunately cause some incompatabilities in the interface.
.LP
.LP
.SH AUTHOR
.LP
brian.warkentine@Eng.Sun.COM
